"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.send = exports.put = exports.post = exports.get = exports.del = exports.request = exports.mkFetch = exports.HttpErrorResponse = void 0;
const E = __importStar(require("fp-ts/lib/Either"));
const function_1 = require("fp-ts/lib/function");
const TE = __importStar(require("fp-ts/lib/TaskEither"));
const ts_union_1 = require("ts-union");
const R = __importStar(require("fp-ts/lib/Record"));
const J = __importStar(require("fp-ts/lib/Json"));
const Cmd_1 = require("./Cmd");
exports.HttpErrorResponse = (0, ts_union_1.Union)({
    BadStatusError: (0, ts_union_1.of)(),
    UnknownError: (0, ts_union_1.of)(),
    ParseError: (0, ts_union_1.of)(),
    ValidationErrors: (0, ts_union_1.of)()
});
const parseError = (error) => exports.HttpErrorResponse.ParseError(E.toError(error));
const convertHeaders = (headers) => {
    let result = {};
    headers.forEach((value, key) => {
        result = R.upsertAt(key, value)(result);
    });
    return result;
};
const convertResponse = (response, body) => ({
    headers: convertHeaders(response.headers),
    status: {
        code: response.status,
        text: response.statusText
    },
    body,
    url: response.url
});
function mkFetch(defaults = {}) {
    return req => (0, function_1.pipe)(TE.tryCatch(() => {
        var _a;
        return window.fetch(((_a = defaults.baseUrl) !== null && _a !== void 0 ? _a : '') + req.url, Object.assign(Object.assign(Object.assign({}, defaults), req), { body: typeof req.body !== 'undefined' ? JSON.stringify(req.body) : defaults.body }));
    }, E.toError), TE.chain(response => (0, function_1.pipe)(TE.tryCatch(() => response.text(), E.toError), TE.map(body => convertResponse(response, body)))));
}
exports.mkFetch = mkFetch;
const request = (req) => env => (0, function_1.pipe)(env.http(req), TE.mapLeft(exports.HttpErrorResponse.UnknownError), TE.chain(response => response.status.code >= 400 ? TE.left(exports.HttpErrorResponse.BadStatusError(response)) : TE.right(response)), TE.chain(response => (0, function_1.pipe)(J.parse(response.body), E.mapLeft(parseError), E.chain(json => (0, function_1.pipe)(req.decoder.decode(json), E.bimap(errors => exports.HttpErrorResponse.ValidationErrors(errors, json), body => (Object.assign(Object.assign({}, response), { body }))))), TE.fromEither)));
exports.request = request;
const del = (url, decoder) => ({
    url,
    method: 'DELETE',
    decoder
});
exports.del = del;
const get = (url, decoder) => ({
    url,
    method: 'GET',
    decoder,
    headers: {
        'Content-Type': 'application/json'
    }
});
exports.get = get;
const post = (url, body, decoder) => ({
    url,
    method: 'POST',
    decoder,
    headers: {
        'Content-Type': 'application/json'
    },
    body
});
exports.post = post;
const put = (url, body, decoder) => ({
    url,
    method: 'PUT',
    decoder,
    headers: {
        'Content-Type': 'application/json'
    },
    body
});
exports.put = put;
const send = (req, f) => (0, Cmd_1.attempt)((0, exports.request)(req), f);
exports.send = send;
//# sourceMappingURL=Http.js.map