import * as RO from 'fp-ts-rxjs/lib/ReaderObservable';
import { Applicative as FpApplicative, Applicative3 } from 'fp-ts/lib/Applicative';
import { Apply3 } from 'fp-ts/lib/Apply';
import { Bifunctor3 } from 'fp-ts/lib/Bifunctor';
import { Chain3 } from 'fp-ts/lib/Chain';
import { Comonad3 } from 'fp-ts/lib/Comonad';
import { Extend3 } from 'fp-ts/lib/Extend';
import { Foldable3 } from 'fp-ts/lib/Foldable';
import { Functor3 } from 'fp-ts/lib/Functor';
import { HKT } from 'fp-ts/lib/HKT';
import { Monad3 } from 'fp-ts/lib/Monad';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Pointed3 } from 'fp-ts/lib/Pointed';
import { Semigroup } from 'fp-ts/lib/Semigroup';
import { Semigroupoid3 } from 'fp-ts/lib/Semigroupoid';
import { Traversable3 } from 'fp-ts/lib/Traversable';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind3<R, E, A> {
        'effe-ts/State': State<R, A, E>;
    }
}
export declare const URI = "effe-ts/State";
export declare type URI = typeof URI;
export declare type State<R, Model, Action = never> = [Model, RO.ReaderObservable<R, Action>];
export declare const fromModel: <R, Model>(model: Model) => State<R, Model, never>;
export declare const model: <R, Model>(state: State<R, Model, unknown>) => Model;
export declare const cmd: <R, Action>(state: State<R, unknown, Action>) => RO.ReaderObservable<R, Action>;
export declare function getSemigroup<R, Model, Action>(S: Semigroup<Model>): Semigroup<State<R, Model, Action>>;
export declare function getMonoid<R, Model, Action>(M: Monoid<Model>): Monoid<State<R, Model, Action>>;
export declare const map: <R, Action, A, B>(f: (a: A) => B) => (ma: State<R, A, Action>) => State<R, B, Action>;
export declare const Functor: Functor3<URI>;
export declare const of: Pointed3<URI>['of'];
export declare const Pointed: Pointed3<URI>;
export declare const ap: <R, Action, A>(fa: State<R, A, Action>) => <B>(fab: State<R, (a: A) => B, Action>) => State<R, B, Action>;
export declare const Apply: Apply3<URI>;
export declare const Applicative: Applicative3<URI>;
export declare const chain: <R, E, A, B>(f: (a: A) => State<R, B, E>) => (ma: State<R, A, E>) => State<R, B, E>;
export declare const chainW: <R2, E2, A, B>(f: (a: A) => State<R2, B, E2>) => <R1, E1>(ma: State<R1, A, E1>) => State<R1 & R2, B, E1 | E2>;
export declare const Chain: Chain3<URI>;
export declare const Monad: Monad3<URI>;
export declare const foldMap: <M>(M: Monoid<M>) => <R, E, A>(f: (a: A) => M) => (fa: State<R, A, E>) => M;
export declare const reduce: <R, A, B>(b: B, f: (b: B, a: A) => B) => <E>(fa: State<R, A, E>) => B;
export declare const reduceRight: <R, A, B>(b: B, f: (a: A, b: B) => B) => <E>(fa: State<R, A, E>) => B;
export declare const Foldable: Foldable3<URI>;
export declare const traverse: <F>(F: FpApplicative<F>) => <A, B>(f: (a: A) => HKT<F, B>) => <R, S>(as: State<R, A, S>) => HKT<F, State<R, B, S>>;
export declare const sequence: <F>(F: FpApplicative<F>) => <R, A, S>(fas: State<R, HKT<F, A>, S>) => HKT<F, State<R, A, S>>;
export declare const Traversable: Traversable3<URI>;
export declare const bimap: <E, G, A, B>(f: (e: E) => G, g: (a: A) => B) => <R>(fa: State<R, A, E>) => State<R, B, G>;
export declare const mapLeft: <E, G>(f: (e: E) => G) => <R, A>(fa: State<R, A, E>) => State<R, A, G>;
export declare const Bifunctor: Bifunctor3<URI>;
export declare const compose: <R, A, B, C>(la: State<R, B, A>) => (ab: State<R, C, B>) => State<R, C, A>;
export declare const Semigroupoid: Semigroupoid3<URI>;
export declare const extend: <R, E, A, B>(f: (wa: State<R, A, E>) => B) => (wa: State<R, A, E>) => State<R, B, E>;
export declare const Extend: Extend3<URI>;
export declare const extract: Comonad3<URI>['extract'];
export declare const Comonad: Comonad3<URI>;
export declare const apFirst: <R, E, B>(second: State<R, B, E>) => <A>(first: State<R, A, E>) => State<R, A, E>;
export declare const apSecond: <R, E, B>(second: State<R, B, E>) => <A>(first: State<R, A, E>) => State<R, B, E>;
export declare const chainFirst: <A, R, E, B>(f: (a: A) => State<R, B, E>) => (first: State<R, A, E>) => State<R, A, E>;
export declare const duplicate: <R, E, A>(wa: State<R, A, E>) => State<R, State<R, A, E>, E>;
export declare const flatten: <R, E, A>(mma: State<R, State<R, A, E>, E>) => State<R, A, E>;
export declare const flap: <A>(a: A) => <R, E, B>(fab: State<R, (a: A) => B, E>) => State<R, B, E>;
export declare const Do: State<unknown, Record<string, never>, never>;
export declare const bindTo: <N extends string>(name: N) => <R, E, A>(fa: State<R, A, E>) => State<R, { readonly [K in N]: A; }, E>;
export declare const bind: <N extends string, A, R, E, B>(name: Exclude<N, keyof A>, f: (a: A) => State<R, B, E>) => (ma: State<R, A, E>) => State<R, { readonly [K in N | keyof A]: K extends keyof A ? A[K] : B; }, E>;
export declare const bindW: <N extends string, A, R2, E2, B>(name: Exclude<N, keyof A>, f: (a: A) => State<R2, B, E2>) => <R1, E1>(fa: State<R1, A, E1>) => State<R1 & R2, {
    readonly [K in keyof A | N]: K extends keyof A ? A[K] : B;
}, E1 | E2>;
export declare const apS: <N extends string, A, R, E, B>(name: Exclude<N, keyof A>, fb: State<R, B, E>) => (fa: State<R, A, E>) => State<R, { readonly [K in N | keyof A]: K extends keyof A ? A[K] : B; }, E>;
export declare const apSW: <A, N extends string, R2, E2, B>(name: Exclude<N, keyof A>, fb: State<R2, B, E2>) => <R1, E1>(fa: State<R1, A, E1>) => State<R1 & R2, {
    readonly [K in keyof A | N]: K extends keyof A ? A[K] : B;
}, E1 | E2>;
export declare const ApT: State<unknown, readonly [], never>;
/**
 * @deprecated
 */
export declare const state: Semigroupoid3<URI> & Comonad3<URI> & Traversable3<URI> & Foldable3<URI> & Monad3<URI>;
