"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.purge = exports.save = exports.load = exports.remove = exports.set = exports.get = exports.memoryStorage = exports.localStorage = exports.entity = exports.StorageError = void 0;
const TE = __importStar(require("fp-ts/lib/TaskEither"));
const E = __importStar(require("fp-ts/lib/Either"));
const O = __importStar(require("fp-ts/lib/Option"));
const ts_union_1 = require("ts-union");
const function_1 = require("fp-ts/lib/function");
const IORef_1 = require("fp-ts/lib/IORef");
const R = __importStar(require("fp-ts/lib/Record"));
const Cmd_1 = require("./Cmd");
exports.StorageError = (0, ts_union_1.Union)({
    NativeError: (0, ts_union_1.of)(),
    ValidationErrors: (0, ts_union_1.of)()
});
const entity = (key, type) => ({
    key,
    type
});
exports.entity = entity;
exports.localStorage = {
    get: key => TE.tryCatch(() => __awaiter(void 0, void 0, void 0, function* () { return O.fromNullable(JSON.parse(window.localStorage.getItem(key) || 'null')); }), E.toError),
    set: (key, value) => TE.tryCatch(() => __awaiter(void 0, void 0, void 0, function* () { return window.localStorage.setItem(key, JSON.stringify(value)); }), E.toError),
    remove: key => TE.tryCatch(() => __awaiter(void 0, void 0, void 0, function* () { return window.localStorage.removeItem(key); }), E.toError)
};
function memoryStorage(store = new IORef_1.IORef({})) {
    return {
        get: key => (0, function_1.pipe)(TE.rightIO(store.read), TE.map(store => R.lookup(key, store))),
        set: (key, value) => TE.rightIO(store.modify(R.upsertAt(key, value))),
        remove: key => TE.rightIO(store.modify(R.deleteAt(key)))
    };
}
exports.memoryStorage = memoryStorage;
const get = (entity) => env => (0, function_1.pipe)(env.storage.get(entity.key), TE.mapLeft(exports.StorageError.NativeError), TE.chain((0, function_1.flow)(O.traverse(E.Applicative)(value => (0, function_1.pipe)(entity.type.decode(value), E.mapLeft(errors => exports.StorageError.ValidationErrors(errors, value)))), TE.fromEither)));
exports.get = get;
const set = (entity) => (value) => env => (0, function_1.pipe)(env.storage.set(entity.key, entity.type.encode(value)), TE.mapLeft(exports.StorageError.NativeError));
exports.set = set;
const remove = (entity) => env => (0, function_1.pipe)(env.storage.remove(entity.key), TE.mapLeft(exports.StorageError.NativeError));
exports.remove = remove;
const load = (entity, f) => (0, Cmd_1.attempt)((0, exports.get)(entity), f);
exports.load = load;
const save = (entity) => (value) => (0, Cmd_1.perform_)((0, exports.set)(entity)(value));
exports.save = save;
const purge = (entity) => (0, Cmd_1.perform_)((0, exports.remove)(entity));
exports.purge = purge;
//# sourceMappingURL=Storage.js.map